
from PyQt5.QtCore import (QCoreApplication, QDate, QDateTime, QLocale,
                          QMetaObject, QObject, QPoint, QRect, pyqtSignal,
                          QSize, QTime, QUrl, Qt, QPropertyAnimation)
from PyQt5.QtGui import (QBrush, QColor, QConicalGradient, QCursor,
                         QFont, QFontDatabase, QGradient, QIcon, QMovie,
                         QImage, QKeySequence, QLinearGradient, QPainter,
                         QPalette, QPixmap, QRadialGradient, QTransform)
from PyQt5.QtWidgets import (QApplication, QFrame, QGridLayout, QHBoxLayout,
                             QLabel, QMainWindow, QSizePolicy, QVBoxLayout, QRadioButton, QStackedWidget, QVBoxLayout,
                             QWidget)
from PyQt5.QtWidgets import QGraphicsDropShadowEffect, QGraphicsOpacityEffect
from PyQt5.QtCore import Qt, QTimer, QThread
import threading
import serial
from log import Logging
import resources
import os
import sys
from ui_Menu import Ui_MainWindow as ui_menu
from ui_select_customer import Ui_MainWindow as ui_select
from ui_Pay import Ui_MainWindow as ui_pay
from ui_sorry import Ui_MainWindow as ui_sorry
from ui_wait import Ui_MainWindow as ui_wait
from ui import Ui_MainWindow as ui_main
from machine import Machine
from time import sleep
from send_data import SendData
from check_supply import CheckSupply
from unic_ID import UnicID
from RFID import RFID
from com import Arduino
r = resources
r.qInitResources()

script_dir = os.path.dirname(os.path.abspath(__file__))
os.chdir(script_dir)
sys.path.append(script_dir)

class Page_Main(QMainWindow, ui_main):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        # set objects on Menu page
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAttribute(Qt.WA_TranslucentBackground, True)

class Page_Menu(QMainWindow, ui_menu):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        # set objects on Menu page
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAttribute(Qt.WA_TranslucentBackground, True)

        self.Menu_info = None

        # set shadows
        self.shdow = []
        for i in range(8):
            self.i = QGraphicsDropShadowEffect()
            self.i.setBlurRadius(15)
            self.i.setOffset(0)
            self.i.setColor(QColor(0, 0, 0))
            self.shdow.append(self.i)
        self.m = [self.menu_1, self.menu_2, self.menu_3, self.menu_4,
                  self.menu_5, self.menu_6, self.menu_7, self.menu_8]
        self.b = 0
        for i in self.m:
            i.setGraphicsEffect(self.shdow[self.b])
            self.b += 1

        # set menu name and price
        self.list_txt = ["Menu_1.txt", "Menu_2.txt", "Menu_3.txt", "Menu_4.txt"
            , "Menu_5.txt", "Menu_6.txt", "Menu_7.txt", "Menu_8.txt"]
        # creat dict for each menu
        self.m_1 = {}
        self.m_2 = {}
        self.m_3 = {}
        self.m_4 = {}
        self.m_5 = {}
        self.m_6 = {}
        self.m_7 = {}
        self.m_8 = {}

        # put the menu dict to a list for use in  for loop
        self.list_manu = [self.m_1, self.m_2, self.m_3, self.m_4, self.m_5, self.m_6, self.m_7, self.m_8]

        # first loop for open menu.txt and second loop for put the key and val in each menu dict
        z = 0
        for file in self.list_txt:
            with open(file, 'r', encoding='utf8') as f:
                for line in f:
                    key, val = line.strip().split(':')
                    try:
                        val = float(val)
                    except:
                        val = val
                    self.list_manu[z][key] = val
            z += 1

        # put show name and price value in the list
        List_names = [self.L_name_1, self.L_name_2, self.L_name_3, self.L_name_4,
                      self.L_name_5, self.L_name_6, self.L_name_7, self.L_name_8]
        List_price = [self.L_price_1, self.L_price_2, self.L_price_3, self.L_price_4,
                      self.L_price_5, self.L_price_6, self.L_price_7, self.L_price_8]
        # set name and price ein app
        j = 0
        for j in range(len(List_names)):
            List_names[j].setText(self.list_manu[j]["name"])
            List_price[j].setText(str(int(self.list_manu[j]["price"])))
            j += 1


class Page_Select(QMainWindow, ui_select):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        # set objects on Menu page
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAttribute(Qt.WA_TranslucentBackground, True)

        self.sugar_0.setText("بدون شکر      ")
        self.sugar_1.setText("معمولی        ")
        self.sugar_2.setText("شیرین         ")
        self.coffee_1.setText("کم            ")
        self.coffee_2.setText("متوسط         ")
        self.coffee_3.setText("زیاد           ")

        self.radio_style = """
            QRadioButton {   
                background-color: none; 
                border: 2px solid black;
                border-radius: 30px;     
                padding: 0px;          
                text-align: center;      
                font: 17pt \"2  Mehr\";   
                spacing: 0px;

            }
            QRadioButton:hover {
                background-color: none;  
            }
            QRadioButton::indicator { 
                width: 0px; 
                height: 0px;
                margin-right: 10px;
            }
            QRadioButton:checked {
                background-color: rgb(170, 85, 0); 
                border: 2px solid black;
                padding: 0px;
            }
        """

        self.sugar_0.setStyleSheet(self.radio_style)
        self.sugar_1.setStyleSheet(self.radio_style)
        self.sugar_2.setStyleSheet(self.radio_style)

        self.coffee_1.setStyleSheet(self.radio_style)
        self.coffee_2.setStyleSheet(self.radio_style)
        self.coffee_3.setStyleSheet(self.radio_style)

        self.shadow(self.sugar_0, 50)
        self.shadow(self.sugar_1, 50)
        self.shadow(self.sugar_2, 50)

        self.shadow(self.coffee_1, 50)
        self.shadow(self.coffee_2, 50)
        self.shadow(self.coffee_3, 50)



        button_style = """
            #paymant_button {
                background-color: rgb(170, 85, 0); 
                border: 2px solid black;     
                border-radius: 30px;     
                font: 20pt \"2  Mehr\";
                text-align: center;        
            }
            #back_button {
                background-color: rgb(170, 85, 0); 
                border: 2px solid black;     
                border-radius: 30px;     
                font: 20pt \"2  Mehr\";
                text-align: center;        
            }
            
            #label_5 {
            background: none; 
            border: 0px;
            font: 20pt \"2  Mehr\";
            text-align: center; 
            }
            
            #label_6 {
            background: none; 
            border: 0px;
            font: 20pt \"2  Mehr\";
            text-align: center; 
            }
        """


        self.paymant_button.setStyleSheet(button_style)
        self.label_6.setStyleSheet(button_style)
        self.back_button.setStyleSheet(button_style)
        self.label_5.setStyleSheet(button_style)

        self.paymant_button.setMaximumSize(QSize(150, 75))
        self.paymant_button.setMinimumSize(QSize(150, 75))
        self.back_button.setMaximumSize(QSize(150, 75))
        self.back_button.setMinimumSize(QSize(150, 75))

        self.shadow(self.paymant_button, 30)
        self.shadow(self.back_button, 30)



    def opacity(self, object, op):
        if op != 1 :
            object.setEnabled(False)
        else :
            object.setEnabled(True)
        opacity_effect = QGraphicsOpacityEffect()
        opacity_effect.setOpacity(op)
        object.setGraphicsEffect(opacity_effect)

    def shadow(self, object, shadow):
        shadow_effect = QGraphicsDropShadowEffect()
        shadow_effect.setOffset(0)
        shadow_effect.setBlurRadius(shadow)
        shadow_effect.setColor(QColor(0, 0, 0))
        object.setGraphicsEffect(shadow_effect)




class Page_Pay(QMainWindow, ui_pay):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAttribute(Qt.WA_TranslucentBackground, True)

        # set objects of the Pay page
        # set frame less
        self.frame.setWindowOpacity(0)
        # set shadow
        self.shadow_frame = QGraphicsDropShadowEffect()
        self.shadow_frame.setBlurRadius(30)
        self.shadow_frame.setOffset(0)
        self.shadow_frame.setColor(QColor(0, 0, 0))
        self.frame_2.setGraphicsEffect(self.shadow_frame)
        # set pay gif
        self.movie = QMovie(u":/image/picture/Animation - 1731767884090.gif")
        self.label.setMovie(self.movie)
        self.label.setScaledContents(True)
        self.movie.start()

class Page_Sorry(QMainWindow, ui_sorry):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAttribute(Qt.WA_TranslucentBackground, True)

        # set objects of the Pay page
        # set frame less
        self.frame.setWindowOpacity(0)
        # set shadow
        self.shadow_frame = QGraphicsDropShadowEffect()
        self.shadow_frame.setBlurRadius(30)
        self.shadow_frame.setOffset(0)
        self.shadow_frame.setColor(QColor(0, 0, 0))
        self.frame_2.setGraphicsEffect(self.shadow_frame)


class Page_Wite(QMainWindow, ui_wait):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAttribute(Qt.WA_TranslucentBackground, True)

        # set objects of the Pay page
        # set frame less
        self.frame.setWindowOpacity(0)
        # set shadow
        self.shadow_frame = QGraphicsDropShadowEffect()
        self.shadow_frame.setBlurRadius(30)
        self.shadow_frame.setOffset(0)
        self.shadow_frame.setColor(QColor(0, 0, 0))
        self.frame_2.setGraphicsEffect(self.shadow_frame)
        # set pay gif
        self.movie = QMovie(u":/image/picture/Animation - 1731767884090.gif")
        self.label.setMovie(self.movie)
        self.label.setScaledContents(True)
        self.movie.start()


class MainWindow(QMainWindow):
    def __init__(self):
        super().__init__()

        self.send = SendData()
        self.log_manu = Logging("menu")
        self.arduino = Arduino()
        self.rfid = RFID("ID_Card.txt")
        self.ID = None
        self.idCard = None
        self.orderID = None

        # Initialize the pages
        self.pageMenu = Page_Menu()
        self.pageSelect = Page_Select()
        self.pagePay = Page_Pay()
        self.pageSorry = Page_Sorry()
        self.pageWite = Page_Wite()
        self.pageMain = Page_Main()

        self.a = False


        # Initialize the static variables
        self.amountCoffee = 1
        self.amountPowderCoffee = 1
        self.amountMilk = 1
        self.amountSugar = 1
        self.coffee_powder = None
        self.coffee = None
        self.hot_milk = None
        self.froth_milk = None
        self.sugar = None

        # Clicking setup for page menu

        self.pageMenu.menu_1.mousePressEvent = self.Button_Menu_1
        self.pageMenu.menu_2.mousePressEvent = self.Button_Menu_2
        self.pageMenu.menu_3.mousePressEvent = self.Button_Menu_3
        self.pageMenu.menu_4.mousePressEvent = self.Button_Menu_4
        self.pageMenu.menu_5.mousePressEvent = self.Button_Menu_5
        self.pageMenu.menu_6.mousePressEvent = self.Button_Menu_6
        self.pageMenu.menu_7.mousePressEvent = self.Button_Menu_7
        self.pageMenu.menu_8.mousePressEvent = self.Button_Menu_8

        self.pageSelect.frame_sugar.setEnabled(True)
        self.pageSelect.frame_coffee.setEnabled(True)

        self.pageSelect.coffee_1.setChecked(False)
        self.pageSelect.coffee_2.setChecked(False)
        self.pageSelect.coffee_3.setChecked(False)
        self.pageSelect.sugar_0.setChecked(False)
        self.pageSelect.sugar_1.setChecked(False)
        self.pageSelect.sugar_2.setChecked(False)

        # chech in 1 sec

        self.timer_menu_page = QTimer(self)
        self.timer_menu_page.timeout.connect(self.check_menu_page)
        self.timer_menu_page.start(100)

        self.timer_select = QTimer(self)
        self.timer_select.timeout.connect(self.check_select_page)
        self.timer_select.start(100)

        self.timer_pay = QTimer(self)
        self.timer_pay.timeout.connect(self.check_pay_page)
        self.timer_pay.start(100)




        # Clicking setup for page select
        self.pageSelect.back_button.mousePressEvent = self.back_button
        self.pageSelect.paymant_button.mousePressEvent = self.pay_button
        # self.pagePay.frame_2.mousePressEvent = self.Run_machine




    # check eich sec
    def check_menu_page (self):
        if self.pageMenu.isVisible() :
            self.a = False
            # check supply to show menu
            self.check_supply = CheckSupply("Supply.txt")
            water = self.check_supply.check_supply("water", 50)
            coffee = self.check_supply.check_supply("coffee", 50)
            milk = self.check_supply.check_supply("milk", 50)

            if not water :
                self.pageMenu.menu_1.mousePressEvent = 0
                self.pageMenu.menu_2.mousePressEvent = 0
                self.pageMenu.menu_3.mousePressEvent = 0
                self.pageMenu.menu_4.mousePressEvent = 0
                self.pageMenu.menu_5.mousePressEvent = 0
                self.pageMenu.menu_6.mousePressEvent = 0
                self.pageMenu.menu_7.mousePressEvent = 0
                self.pageMenu.menu_8.mousePressEvent = 0
                # set shadows
                self.pageSelect.opacity(self.pageMenu.menu_1, 0.3)
                self.pageSelect.opacity(self.pageMenu.menu_2, 0.3)
                self.pageSelect.opacity(self.pageMenu.menu_3, 0.3)
                self.pageSelect.opacity(self.pageMenu.menu_4, 0.3)
                self.pageSelect.opacity(self.pageMenu.menu_5, 0.3)
                self.pageSelect.opacity(self.pageMenu.menu_6, 0.3)
                self.pageSelect.opacity(self.pageMenu.menu_7, 0.3)
                self.pageSelect.opacity(self.pageMenu.menu_8, 0.3)

            if water :
                if not coffee and milk :
                    self.pageMenu.menu_1.mousePressEvent = 0
                    self.pageMenu.menu_2.mousePressEvent = 0
                    self.pageMenu.menu_3.mousePressEvent = 0
                    self.pageMenu.menu_4.mousePressEvent = 0
                    self.pageMenu.menu_5.mousePressEvent = 0
                    self.pageMenu.menu_6.mousePressEvent = 0
                    self.pageMenu.menu_7.mousePressEvent = self.Button_Menu_7
                    self.pageMenu.menu_8.mousePressEvent = self.Button_Menu_8

                    # set shadows
                    self.pageSelect.opacity(self.pageMenu.menu_1, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_2, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_3, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_4, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_5, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_6, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_7, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_8, 1)

                    self.pageSelect.shadow(self.pageMenu.menu_7, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_8, 30)

                elif coffee and not milk :
                    self.pageMenu.menu_1.mousePressEvent = self.Button_Menu_1
                    self.pageMenu.menu_2.mousePressEvent = self.Button_Menu_2
                    self.pageMenu.menu_3.mousePressEvent = self.Button_Menu_3
                    self.pageMenu.menu_4.mousePressEvent = 0
                    self.pageMenu.menu_5.mousePressEvent = 0
                    self.pageMenu.menu_6.mousePressEvent = 0
                    self.pageMenu.menu_7.mousePressEvent = 0
                    self.pageMenu.menu_8.mousePressEvent = 0

                    self.pageSelect.opacity(self.pageMenu.menu_1, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_2, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_3, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_4, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_5, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_6, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_7, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_8, 0.3)

                    self.pageSelect.shadow(self.pageMenu.menu_1, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_2, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_3, 30)

                elif not coffee and not milk :
                    self.pageMenu.menu_1.mousePressEvent = 0
                    self.pageMenu.menu_2.mousePressEvent = 0
                    self.pageMenu.menu_3.mousePressEvent = 0
                    self.pageMenu.menu_4.mousePressEvent = 0
                    self.pageMenu.menu_5.mousePressEvent = 0
                    self.pageMenu.menu_6.mousePressEvent = 0
                    self.pageMenu.menu_7.mousePressEvent = 0
                    self.pageMenu.menu_8.mousePressEvent = 0
                    # set shadows
                    self.pageSelect.opacity(self.pageMenu.menu_1, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_2, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_3, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_4, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_5, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_6, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_7, 0.3)
                    self.pageSelect.opacity(self.pageMenu.menu_8, 0.3)
                else :
                    self.pageMenu.menu_1.mousePressEvent = self.Button_Menu_1
                    self.pageMenu.menu_2.mousePressEvent = self.Button_Menu_2
                    self.pageMenu.menu_3.mousePressEvent = self.Button_Menu_3
                    self.pageMenu.menu_4.mousePressEvent = self.Button_Menu_4
                    self.pageMenu.menu_5.mousePressEvent = self.Button_Menu_5
                    self.pageMenu.menu_6.mousePressEvent = self.Button_Menu_6
                    self.pageMenu.menu_7.mousePressEvent = self.Button_Menu_7
                    self.pageMenu.menu_8.mousePressEvent = self.Button_Menu_8

                    self.pageSelect.opacity(self.pageMenu.menu_1, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_2, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_3, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_4, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_5, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_6, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_7, 1)
                    self.pageSelect.opacity(self.pageMenu.menu_8, 1)

                    self.pageSelect.shadow(self.pageMenu.menu_1, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_2, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_3, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_4, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_5, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_6, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_7, 30)
                    self.pageSelect.shadow(self.pageMenu.menu_8, 30)


    def check_select_page(self):
        if self.pageSelect.isVisible():
            self.pageSelect.opacity(self.pageSelect.frame_paymant, 1)
            self.pageSelect.shadow(self.pageSelect.frame_paymant, 30)
            self.check_supply = CheckSupply("Supply.txt")
            sugar = self.check_supply.check_supply("sugar", 50)

            if self.num_menu in [7, 8] :
                self.pageSelect.opacity(self.pageSelect.frame_coffee, 0.3)
                self.pageSelect.opacity(self.pageSelect.frame_sugar, 1)
                self.pageSelect.shadow(self.pageSelect.frame_sugar, 30)

            elif self.num_menu in [1, 2, 3] :
                self.pageSelect.opacity(self.pageSelect.frame_sugar, 0.3)
                self.pageSelect.opacity(self.pageSelect.frame_coffee, 1)
                self.pageSelect.shadow(self.pageSelect.frame_coffee, 30)

            else :
                self.pageSelect.opacity(self.pageSelect.frame_coffee, 1)
                self.pageSelect.shadow(self.pageSelect.frame_coffee, 30)
                self.pageSelect.opacity(self.pageSelect.frame_sugar, 1)
                self.pageSelect.shadow(self.pageSelect.frame_sugar, 30)

            if not sugar :
                self.pageSelect.opacity(self.pageSelect.frame_sugar, 0.3)


    def check_pay_page(self):
        if self.pagePay.isVisible():
            if self.pagePay.isVisible():
                self.idCard = self.arduino.main("5")
                valid = self.rfid.identify(self.idCard)
                if valid:
                    # self.pageWite.show()
                    self.pagePay.close()
                    threading.Thread(target=self.Run_machine, daemon=True).start()






                    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_1(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_1.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_1.text())
            self.num_menu = 1

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(False)

            self.pageSelect.show()
            self.pageMenu.close()

    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_2(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_2.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_2.text())
            self.num_menu = 2

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(True)

            self.pageSelect.show()
            self.pageMenu.close()

    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_3(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_3.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_3.text())
            self.num_menu = 3

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(True)

            self.pageSelect.show()
            self.pageMenu.close()

    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_4(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_4.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_4.text())
            self.num_menu = 4

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(True)

            self.pageSelect.show()
            self.pageMenu.close()

    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_5(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_5.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_5.text())
            self.num_menu = 5

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(True)

            self.pageSelect.show()
            self.pageMenu.close()

    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_6(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_6.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_6.text())
            self.num_menu = 6

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(True)

            self.pageSelect.show()
            self.pageMenu.close()


    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_7(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_7.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_7.text())
            self.num_menu = 7

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(True)

            self.pageSelect.show()
            self.pageMenu.close()
    # set menu name and price in select page and show select page
    # set number of selected menu
    def Button_Menu_8(self, event):
        if event.button() == Qt.LeftButton:
            self.pageSelect.price.setText(self.pageMenu.L_price_8.text())
            self.pageSelect.name.setText(self.pageMenu.L_name_8.text())
            self.num_menu = 8

            self.pageSelect.coffee_2.setChecked(True)
            self.pageSelect.sugar_1.setChecked(True)

            self.pageSelect.show()
            self.pageMenu.close()

    # Back to menu page
    def back_button(self, event):
        if event.button() == Qt.LeftButton:
            self.num_menu = 0

            self.pageSelect.coffee_2.setChecked(False)
            self.pageSelect.sugar_1.setChecked(False)

            self.pageMenu.show()
            self.pageSelect.close()


    # function for sent price to POS and wait to receive result of POS
    def pay_button(self, event):
        if event.button() == Qt.LeftButton:
            # add name and price of menu
            self.pagePay.label_2.setText(self.pageSelect.price.text())
            self.pagePay.label_3.setText(self.pageSelect.name.text())

            # show pay page

            self.pagePay.show()
            self.pageSelect.close()


    def Run_machine(self):
        try :
            self.pageWite.show()
            self.pagePay.close()
            self.ID = UnicID()
            self.orderID = self.ID.generate_order_id()


            # take number of sugar
            if self.pageSelect.sugar_0.isChecked():
                self.amountSugar = 0
            elif self.pageSelect.sugar_1.isChecked():
                self.amountSugar = 1
            elif self.pageSelect.sugar_2.isChecked():
                self.amountSugar = 1.5

            # take number of coffee

            if self.pageSelect.coffee_1.isChecked():
                self.amountPowderCoffee = 0.842
                self.amountCoffee = 0.75
                self.amountMilk = 0.75
            elif self.pageSelect.coffee_2.isChecked():
                self.amountPowderCoffee = 1
                self.amountCoffee = 1
                self.amountMilk = 1
            elif self.pageSelect.coffee_3.isChecked():
                self.amountPowderCoffee = 1.157
                self.amountCoffee = 1.25
                self.amountMilk = 1.25

            # create dictionary of menu information
            self.dic_Menu_info = None
            name = ""
            # choose selected menu and add menu address
            if self.num_menu == 1:
                self.dic_Menu_info = self.pageMenu.m_1
                name += "Espresso"
            elif self.num_menu == 2:
                self.dic_Menu_info = self.pageMenu.m_2
                name += "Double Espresso"
            elif self.num_menu == 3:
                self.dic_Menu_info = self.pageMenu.m_3
                name += "Americano"
            elif self.num_menu == 4:
                self.dic_Menu_info = self.pageMenu.m_4
                name += "Latte"
            elif self.num_menu == 5:
                self.dic_Menu_info = self.pageMenu.m_5
                name += "Cappuccino"
            elif self.num_menu == 6:
                self.dic_Menu_info = self.pageMenu.m_6
                name += 'Hot Chocolate'
            elif self.num_menu == 7:
                self.dic_Menu_info = self.pageMenu.m_7
                name += "Moka"
            elif self.num_menu == 8:
                self.dic_Menu_info = self.pageMenu.m_8
                name += "Cocoa milk"

            # add select amount coffee and sugar on the main amount
            coffee_powder = self.dic_Menu_info["coffee_powder"] * self.amountPowderCoffee
            coffee = self.dic_Menu_info["coffee"] * self.amountCoffee
            hot_milk = self.dic_Menu_info["hot_milk"] * self.amountMilk
            froth_milk = self.dic_Menu_info["froth_milk"] * self.amountMilk
            sugar = self.dic_Menu_info["sugar"] * self.amountSugar

            name += f"//coffee:{self.amountCoffee}//sugar:{self.amountSugar}"


            # modify machine class
            self.machine = Machine(self.orderID, self.dic_Menu_info['price'], coffee_powder,
                                   coffee, sugar,
                                   hot_milk, froth_milk,
                                   self.dic_Menu_info['chocolate_powder'], self.dic_Menu_info['cocoa_powder'],
                                   "outPin.txt", "perSec.txt")

            # Run machine elements

            self.machine.menu()

            if self.machine.error is True :
                self.pageSorry.show()

            else :

                water = coffee + froth_milk + hot_milk
                milk = froth_milk + hot_milk
                decrease_supply = [water, coffee, milk, sugar,
                                   self.dic_Menu_info['cocoa_powder'],
                                   self.dic_Menu_info['chocolate_powder']]
                supply = self.check_supply.get_supply_dic()

                b = 0
                for j in supply.keys() :
                    self.check_supply.decrease_supply(j, decrease_supply[b])
                    b += 1

                self.log_manu.get_logger(orderID=self.orderID, txt1=name, level=1)
                name = ""
                # send log and data to host
                self.send.send_data(["machine.log", "app.log", "supply.log", "Supply.txt"])
                self.a = True

            self.amountCoffee = 1
            self.amountPowderCoffee = 1
            self.amountMilk = 1
            self.amountSugar = 1

            self.__init__()
            self.pageMenu.show()
            self.pageWite.close()





        except Exception as e :
            print(e)


# Run the application
if __name__ == "__main__":
    app = QApplication(sys.argv)
    window = MainWindow()
    window.pageMain.show()
    window.pageMenu.show()
    sys.exit(app.exec())

