import sys
import os
from log import Logging
from send_data import SendData



class CheckSupply():
    def __init__(self, supply_txt:str):
        self.supply_txt = supply_txt
        self.supply_dic = {}
        self.log_supply = Logging("supply")
        self.send_data_supply = SendData()

    def get_supply_dic(self):
        self.supply_dic = {}
        try :

            with open(self.supply_txt, 'r', encoding='utf-8') as file:
                for line in file:
                    key, val1 = line.strip().split(":")
                    val = float(val1)
                    self.supply_dic[key] = val
            file.close()
            self.log_supply.get_logger("0", f"get_supply_dic passed ", 1)
        except FileNotFoundError as err:
            print(err)
            self.log_supply.get_logger("0", f"{self.supply_txt} Not founded  Error : {err} ", 2)
        except Exception as e :
            print(e)
            self.log_supply.get_logger("0", f"get_supply_dei failed Error : {e} ", 2)
        return self.supply_dic


    def check_supply(self, supply:str, amount_needed:float) :
        self.supply_dic = {}
        try :
            with open(self.supply_txt, 'r', encoding='utf-8') as file:
                for line in file:
                    key, val1 = line.strip().split(":")
                    val = float(val1)
                    self.supply_dic[key] = val
            file.close()
            if self.supply_dic[supply] > amount_needed  :
                return True
            else :
                return False
        except FileNotFoundError as err:
            print(err)
            self.log_supply.get_logger("0",f"{self.supply_txt} Not founded  Error : {err} ", 2)
        except Exception as e :
            print(e)
            self.log_supply.get_logger("0",f"check_supply failed Error : {e} ", 2)


    def increase_supply(self, supply:str, amount_added:float) :
        self.supply_dic = {}
        try :

            with open(self.supply_txt, 'r', encoding='utf-8') as file:
                for line in file:
                    key, val1 = line.strip().split(":")
                    val = float(val1)
                    self.supply_dic[key] = val
                file.close()
            if amount_added > 0 :
                self.supply_dic[supply] += amount_added
                with open(self.supply_txt, 'w', encoding='utf-8') as file:
                    for key, val in self.supply_dic.items() :
                        file.writelines(f'{key}:{val}\n')
                file.close()
            self.log_supply.get_logger("0", f"increase_supply passed and {amount_added} amount product added to {supply} ", 1)
        except FileNotFoundError as err:
            print(err)
            self.log_supply.get_logger("0", f"{self.supply_txt} Not founded  Error : {err} ", 2)
        except Exception as e :
            print(e)
            self.log_supply.get_logger("0", f"increase_supply failed Error : {e} ", 2)
        return self.supply_dic

    def decrease_supply(self, supply:str, amount_take:float) :
        self.supply_dic = {}
        try:
            with open(self.supply_txt, 'r', encoding='utf-8') as file:
                for line in file:
                    key, val1 = line.strip().split(":")
                    val = float(val1)
                    self.supply_dic[key] = val
            file.close()
            if amount_take > 0:
                self.supply_dic[supply] -= amount_take
                with open(self.supply_txt, 'w', encoding='utf-8') as file:
                    for key, val in self.supply_dic.items() :
                        file.writelines(f'{key}:{val}\n')
                    file.close()
            self.log_supply.get_logger("0", f"decrease_supply passed and {amount_take} amount product take to {supply} ", 1)
        except FileNotFoundError as err:
            print(err)
            self.log_supply.get_logger("0", f"{self.supply_txt} Not founded  Error : {err} ", 2)
        except Exception as e:
            print(e)
            self.log_supply.get_logger("0", f"decrease_supply failed Error : {e} ", 2)
        return self.supply_dic