import ast

import serial
import time


class Arduino:
    def __init__(self):
        # Set up the serial connection (replace 'COM3' with your Arduino's port)
        self.arduino = serial.Serial(port='/dev/ttyUSB0', baudrate=9600, timeout=1)
        time.sleep(2)  # Wait for Arduino to initialize

    def send_command(self, Num):
        """Send a command to the Arduino."""
        self.arduino.write(f"{Num}\n".encode())  # Send command with a newline
        time.sleep(0.01)  # Allow Arduino some time to process

    def receive_data(self):
        """Receive data from Arduino."""
        if self.arduino.in_waiting > 0:
            return self.arduino.readline().decode().strip()  # Read and decode bytes
        return None

    def main(self, command):
        # Send some example commands
        self.send_command(command)
        data = self.receive_data()
        return data

    def close(self):
        a = self.arduino.close()
        return a


